function [isfeasp,Vout] = linearizedReach(f,x,w,l1)


Vout = polynomial(0);


fLin = cleanpoly(f,[],1);

A = jacobian(fLin,x);
B = jacobian(fLin,w);


if 1
    % PJS 6/4/2009 SOSOPT
    V = polydecvar('c',monomials(x,2),'vec');
    sosineq{1} = V-l1;
    sosineq{2} = w'*w - jacobian(V,x)*(A*x+B*w);
    [info,dopt]=sosopt(sosineq,[x;w]);
    isfeasp = info.feas;
    if isfeasp
        Vout = subs(V,dopt);
    end    
else
    % Original SOSTOOLs Code
    prog = sosprogram([x;w]);
    [prog,V] = sospolyvar(prog,monomials(x,2));
    prog = sosineq(prog, V-l1);
    ineq2 = w'*w - jacobian(V,x)*(A*x+B*w);
    prog = sosineq(prog, ineq2);
    [prog, info] = sossolve(prog);
    isfeasp = check_feasp(info, 'sedumi');
    if isfeasp
        Vout = sosgetsol(prog, V);
    end
end




% % PJS 9/28/2009
% % On Erin's adap. control problem, this optim is feas
% % for V=x'*P*x where P includes terms in the 4x4 upper left
% % block, the diagonal of the lower right 5x5 block and
% % entries in (8,1), (1,8), (9,2) and (2,9)
% %
% % V = x(1:4)'*mpvar('c',4,4,'s')*x(1:4)...
% %    +sum(x(5:end).^2.*mpvar('d',5,1)) ...
% %   + 2*mpvar('e',1,1)*x(9)*x(2)+2*mpvar('f',1,1)*x(1)*x(8);
% 
% % PJS 9/28/2009 -- Trying a different implementation
% %     Vpsd = polydecvar('c',monomials(x,1),'mat');
% %     V = Vpsd+l1;
% %     sosineq{1} = Vpsd;
% %     sosineq{2} = w'*w - jacobian(V,x)*(A*x+B*w);
% 
% V = polydecvar('c',monomials(x,2),'vec');
% 
% v0 = {'c_4_1'; 'c_5_1'; 'c_7_1'; 'c_8_1'; 'c_11_1'; 'c_12_1'; ...
%     'c_13_1'; 'c_14_1'; 'c_16_1'; 'c_17_1'; 'c_18_1'; 'c_19_1'; ...
%     'c_20_1'; 'c_22_1'; 'c_23_1'; 'c_24_1'; 'c_25_1'; 'c_26_1'; ...
%     'c_27_1'; 'c_31_1'; 'c_32_1'; 'c_33_1'; 'c_34_1'; 'c_35_1'; ...
%     'c_37_1'; 'c_39_1'; 'c_40_1'; 'c_41_1'; 'c_42_1'; 'c_43_1'; ...
%     'c_44_1'};
% V = subs(V,v0,zeros(length(v0),1));
% 
% sosineq{1} = V-l1;
% sosineq{2} = w'*w - jacobian(V,x)*(A*x+B*w);
% opts.fid = 1;
% [info,dopt,sossol]=sosopt(sosineq,[x;w],opts);    
